\documentclass[a4paper,notitlepage,oneside,]{article}
\usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
\usepackage{framed}
%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
\newcommand{\rfc}[1]{\cite{rfc#1}}
\usepackage[backend=biber,style=alphabetic,sorting=ynt]{biblatex}
\addbibresource{rfc9234.bib}
\begin{document}
\frenchspacing
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 6b - Roles of BGP Neighbors}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
\title{Experiment 6b - Roles of BGP Neighbors}
\date{Version 1.0}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\maketitle

\section{Network Setup}
\begin{figure}[H]
  \centering
  \includegraphics[width=\linewidth,page=4]{img/06-blackholing-drawings.pdf}
  \caption{Network Setup}
  \label{fig:networksetup}
\end{figure}
Figure \ref{fig:networksetup} shows the network topology for this experiment.
All students' routers connect to one upstream AS65550 (also running FRRouting in a Docker container). Additionally all studens peer with each other.

\section{Introduction}
Building correct prefix filters in BGP always has been a challenge. Often filters are either too restricted, causing prefixes to be missing from announcements or to open, causing flooding of a full BGP table to where it does not belong.

\rfc{9234} solves this problem by assigning roles to BGP neighbors and automatic filtering according to these roles.


\section{Task: Configure your local role for each BGP neighbor}
\begin{itemize}
  \item Check what BGP neighbors you have
  \item Add a statement to each BGP peer group do define your role.
  \item 
\end{itemize}

\section{Config statements}
\subsection{Roles}
\begin{description}
  \item[neighbor \emph{a.b.c.d} local-role \emph{<role>} [ strict-mode ]] or  
  \item[neighbor \emph{<peer-group-name>} local-role \emph{<role>} [ strict-mode ]] sets your role in peering relationship with either one neighbor or with all neighbors in that peer group. The following roles are possible:
  \begin{description}
    \item[customer] - you receive upstream connectivity from your neighbor. Your neighbor must have role \emph{provider}.
    \item[provider] - you give upstream connectivity to your neighbor. Your neighbor must have role \emph{customer}.
    \item[peer] - you are peering with your neighbor. Your neighbor also must have role \emph{peer}. 
    \item[rs-client] - you are connecting to a route server as neighbor. Your neighbor must hafe role \emph{rs-server}.
    \item[rs-server] - you are a route server and your neighbor must have role \emph{rs-client}.  
  \end{description}
  The BGP session will not come up in case of a mismatch of roles. The session will come up if one side has no role defined \emph{unless} the \emph{strict} keyword is present, then both sides \emph{must} have matching roles configured.
\end{description}

\section{Show commands}
\subsection{Neighbors}
\begin{description}
  \item[show bgp neighbor \emph{a.b.c.d}] or
  \item[show bgp neighbor \emph{x:x::x}] shows all details about that neighbor and the local and remote role at the very top. 
  \end{description}

\appendix
\section{Upstream configuration}
Configuration of the ``upstream provider'', note the absense of any filtering:
\begin{verbatim}
  hostname upstream
  !
  ip route 198.51.100.0/24 Null0
  !
  interface dummy0
   ip address 198.51.100.48/31
  exit
  !
  router bgp 65550
   no bgp default ipv4-unicast
   bgp disable-ebgp-connected-route-check
   neighbor customer peer-group
   neighbor customer local-role provider
   neighbor customer-v6 peer-group
   neighbor 10.200.1.2 remote-as 64501
   neighbor 10.200.1.2 peer-group customer
   neighbor 10.200.2.2 remote-as 64502
   neighbor 10.200.2.2 peer-group customer
   neighbor 10.200.3.2 remote-as 64503
   neighbor 10.200.3.2 peer-group customer
   neighbor 10.200.4.2 remote-as 64504
   neighbor 10.200.4.2 peer-group customer
   neighbor 10.200.5.2 remote-as 64505
   neighbor 10.200.5.2 peer-group customer
   neighbor 2001:db8:200:1::2 remote-as 64501
   neighbor 2001:db8:200:1::2 peer-group customer-v6
   neighbor 2001:db8:200:2::2 remote-as 64502
   neighbor 2001:db8:200:2::2 peer-group customer-v6
   neighbor 2001:db8:200:3::2 remote-as 64503
   neighbor 2001:db8:200:3::2 peer-group customer-v6
   neighbor 2001:db8:200:4::2 remote-as 64504
   neighbor 2001:db8:200:4::2 peer-group customer-v6
   neighbor 2001:db8:200:5::2 remote-as 64505
   neighbor 2001:db8:200:5::2 peer-group customer-v6
   !
   address-family ipv4 unicast
    network 198.51.100.0/24
    neighbor customer activate
    neighbor customer soft-reconfiguration inbound
    neighbor customer route-map customer-in in
    neighbor customer route-map customer-out out
   exit-address-family
   !
   address-family ipv6 unicast
    neighbor customer-v6 activate
    neighbor customer-v6 soft-reconfiguration inbound
    neighbor customer-v6 route-map customer-in in
    neighbor customer-v6 route-map customer-out out
   exit-address-family
  exit
  !
  ip prefix-list my-networks seq 5 permit 198.51.100.0/24 le 32
  !
  route-map customer-in permit 100
  exit
  !
  route-map customer-out permit 100
  exit
  !
  end
\end{verbatim}

\printbibliography
\section{Slides}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Have a look at your BGP table without filtering in place}
\LARGE
\begin{itemize}
\item just do a \textbf{show bgp ipv4}
\end{itemize}

What a mess in the BGP table:
\begin{itemize}
  \item Network 198.51.100.0/24 from your upstream, you also receive via peering (and even prefer it).
  \item Networks originated from your peers (172.16.x.0/24) you receive from \emph{all} peers.
  \item You announce everything to everybody (no filters!).
\end{itemize}

Some other show commands:
\begin{itemize}
\item \textbf{show bgp ipv4 neighbor 10.200.x.3} - check the neighbor role displayed
\item \textbf{show bgp ipv6 neighbor 2001:db8:200:x::3} 
\item \textbf{sho bgp ipv4 unicast neighbors 10.200.x.3 advertised-routes} - you announce everything
\end{itemize}
\end{samepage}

\vspace{1cm}

%----------------------------------------------------------------
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Configure Roles}
\LARGE
\begin{itemize}
\item Start with a role on your upstream sessions
\end{itemize}

\vspace{0.5cm}
\begin{framed}
\begin{verbatim}
conf t

router bgp 645xx
neighbor upstream local-role customer
neighbor upstream-v6 local-role customer

\end{verbatim}
\end{framed}

Check the BGP table again:
\begin{itemize}
\item \textbf{show bgp ipv4} - once all have configured this: notice any difference?
\item \textbf{show bgp neighbor 10.200.xx.3} - check the roles of yourself and your neighbor
\item \textbf{show bgp ipv4 198.51.100.0/24} - do you see any attribute you have not seen before?
\end{itemize}


\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Configure roles to your peers}
\LARGE
\begin{itemize}
\item Now add a role to the session to your peers
\end{itemize}

\vspace{0.5cm}
\begin{framed}
\begin{verbatim}
conf t

router bgp 645xx
  neighbor peering local-role peer
  neighbor peering-v6 local-role peer

\end{verbatim}
\end{framed}

Check the BGP table again:
\begin{itemize}
\item \textbf{show bgp ipv4} - notice any difference?
\item \textbf{show bgp neighbor 80.81.192.1xx} - check the roles of yourself and your neighbor
\item \textbf{show bgp ipv4 172.16.xx.0/24} - do you see any attribute you have not seen before?
\end{itemize}


\end{samepage}
%----------------------------------------------------------------

%----------------------------------------------------------------


\end{document}
